%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            WFPCM_AO
% data: 
% num_c: Number of clusters
% k: One parameter of formula (3.3)
% epsilon: Ttermination criterion
% m: The fuzzfier 
% data_percent: The percentage of data chunk in data set

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [u,c]=WFPCM_AO(data,num_c,K,epsilon,m,data_percent) 
s=size(data);
s1=s(1);
s2=s(2);
chunk_num=floor(1/data_percent);
n_average=floor(s1*data_percent);  
n_last=s1-(chunk_num-1)*n_average;
for i=1:chunk_num
    if i==chunk_num 
        chunk=data((chunk_num-1)*n_average+1:s1,:);
    else
        chunk=data((i-1)*n_average+1:i*n_average,:);
    end
    s_chunk=size(chunk);
    sc1=s_chunk(1);       
    if i==1    
        [u,c]=FCM_AO(chunk,num_c,epsilon,m);
        total_chunk=chunk;   
        w=ones(sc1,1);
        sc_prior=sc1;   
        chunk_current=chunk;
    else
        w1=zeros(num_c,1);
        for i2=1:num_c
            for j=1:sc_prior;
               w1(i2,1)=w1(i2,1)+u(i2,j)*w(j,1);
            end
        end
        w=[w1;ones(sc1,1)];
        sc_prior=num_c+sc1;  
        chunk_current=[c;chunk]; 
        [u,c]=WFCM_AO(chunk_current,num_c,epsilon,m,w); 
    end
    d=PCM_d(c,chunk_current); 
    eta=WPCM_eta(u,d,m,K,w);     
    u=PCM_u(d,eta,m);
    c_prior=c;
    c=WPCM_c(u,chunk_current,m,w) ; 
    total_chunk=[total_chunk;chunk];     
    scatter(chunk(:,1),chunk(:,2),'.b'); 
    hold on;                              
    scatter(c(:,1),c(:,2),'or');       
    axis([0,1,0,1]);
    hold off;                           
    pause;
    while(abs(c_prior-c)>=epsilon)    
         c_prior=c;
         d=PCM_d(c,chunk_current);
         u=PCM_u(d,eta,m);
         c=WPCM_c(u,chunk_current,m,w);
         scatter(chunk(:,1),chunk(:,2),'.b');  
         hold on;                             
         for mm=1:num_c    
             plot(chunk_current(mm,1),chunk_current(mm,2),'*k');
             hold on; 
         end             
         c
         scatter(c(:,1),c(:,2),'or');
         axis([0,1,0,1]);
         hold off;      
         pause;    
    end
end
 
